#define GEOM_DIF
#include "circunf.c"

#define ARQUIVO

double f1(double t) { return 2*cos(t); }
double f2(double t) { return 2*sin(t); }
double f3(double t) { return t; }

void main(void) {

  ponto P, Q, R, C;
  double t1, t2, raio, L = 0.5, dist_Circunf, dist_VTang, tmin;
  vetor v1, v2;
  char nome_arq[80] = "arq2.txt",
       curva[80] = "f(t) = (2 cos(t), 2 sin(t), t)";
  FILE *arq;

  arq = fopen(nome_arq, "at");
  if (arq == NULL) return;

  for (t1 = -3; t1 <= 3; t1 += L) {

  t2 = t1 + L;

  P.x = f1(t1), P.y = f2(t1), P.z = f3(t1);
  Q.x = f1(t2), Q.y = f2(t2), Q.z = f3(t2);

  VetorTangenteACurva(&v1, f1, f2, f3, t1);
  VetorTangenteACurva(&v2, f1, f2, f3, t2);

  if (!ProximoPontoCirc(&R, &C, &raio, P, v1, Q, v2, L)) return;
  dist_Circunf = Dist(R, f1, f2, f3, t2 - 3, t2 + 3, 0.001, &tmin);

  ProximoPontoVetorTangente(&Q, v2, L);
  dist_VTang = Dist(Q, f1, f2, f3, t2 - 3, t2 + 3, 0.001, &tmin);

  printf("\n\n------\n\nt1 = %8.8f  t2 = %8.8f   L = %8.8f\n"
	 "Dist Circunf    = %8.8f\n" "Dist Vetor Tang = %8.8f\n",
	  (float) t1, (float) t2, (float) L,
	 (float) dist_Circunf, (float) dist_VTang);

  printf("\nRaio = %8.8f   Centro = (%8.8f, %8.8f, %8.8f)",
	 raio, C.x, C.y, C.z);
  printf("\nRaio de curvatura = %8.8f\n",
	 (float) 1.0/Curvatura(f1, f2, f3, t2));

  printf("\nR (circunf) = (%8.8f, %8.8f, %8.8f)", R.x, R.y, R.z);
  printf("\nT (tang) = (%8.8f, %8.8f, %8.8f)", Q.x, Q.y, Q.z);

  printf("\n\n%s\n", curva);

  #ifdef ARQUIVO

  fprintf(arq, "\n\n------\n\nt1 = %8.8f  t2 = %8.8f   L = %8.8f\n"
     "Dist Circunf    = %8.8f\n" "Dist Vetor Tang = %8.8f\n",
      (float) t1, (float) t2, (float) L, (float) dist_Circunf,
      (float) dist_VTang);

  fprintf(arq, "\nRaio = %8.8f   Centro = (%8.8f, %8.8f, %8.8f)",
		 raio, C.x, C.y, C.z);
  fprintf(arq, "\nRaio de curvatura = %8.8f\n",
		 (float) 1.0/Curvatura(f1, f2, f3, t2));

  fprintf(arq, "\nR (circunf) = (%8.8f, %8.8f, %8.8f)", R.x, R.y, R.z);
  fprintf(arq, "\nT (tang) = (%8.8f, %8.8f, %8.8f)", Q.x, Q.y, Q.z);

  fprintf(arq, "\n\n%s\n", curva);
  }
  fclose(arq);
  #endif
}
